#include "nvbuf.h"

bool nvbufsurface_init(int* fd, uint32_t width, uint32_t height, int index)
{
	if (!fd)
	{
		return false;
	}

	NvBufSurface* nvbuf_surf = NULL;
	NvBufSurfaceAllocateParams dma_buf_create_params = {0};

	dma_buf_create_params.params.width = width;
	dma_buf_create_params.params.height = height;
	dma_buf_create_params.params.layout = NVBUF_LAYOUT_BLOCK_LINEAR;
	dma_buf_create_params.params.memType = NVBUF_MEM_SURFACE_ARRAY;
	dma_buf_create_params.memtag = NvBufSurfaceTag_VIDEO_DEC;
	dma_buf_create_params.params.colorFormat = NVBUF_COLOR_FORMAT_NV24;
	int ret = NvBufSurfaceAllocate(&nvbuf_surf, 1, &dma_buf_create_params);
	if (ret < 0)
	{
		LOG_E("Failed to create NvBufSurface: %i", *fd);
		return false;
	}

	*fd = nvbuf_surf->surfaceList[0].bufferDesc;
	nvbuf_surf->numFilled = 1;

	LOG_W("        %d | Allocated buffer with fd:%u", index, *fd);
	return true;
}

void nvbufsurface_fini(int fd, int index)
{
	NvBufSurface* nvbuf_surf = NULL;
	NvBufSurfaceFromFd(fd, (void**) &nvbuf_surf);
	if (nvbuf_surf)
	{
		int ret = NvBufSurfaceDestroy(nvbuf_surf);
		if (ret < 0)
		{
			LOG_E("Failed to Destroy NvBufSurface: %i", fd);
		}
		else
		{
			LOG_I("%d | Freed NvBufSurface with fd:%u", index, fd);
		}
	}
	else
	{
		LOG_E("Failed to get NvBufSurface from fd");
	}
}
