#include "render.ph"

// uint32_t findMemoryType(RenderCtx* ctx, uint32_t typeFilter, VkMemoryPropertyFlags properties) {
// 		VkPhysicalDeviceMemoryProperties memProperties;
// 		vkGetPhysicalDeviceMemoryProperties(vk->physicalDevice, &memProperties);
// 		for (uint32_t i = 0; i < memProperties.memoryTypeCount; i++) {
// 			if ((typeFilter & (1 << i)) && (memProperties.memoryTypes[i].propertyFlags & properties) == properties) {
// 				return i;
// 			}
// 		}

// 		THROW_W_DISPLAY("failed to find suitable memory type!");
// 	}

bool render_import_dma_fd(RenderCtx* ctx, int fd, VkDeviceMemory* vkmem, int index)
{
	NvBufSurface* nvbuf_surf = NULL;
	NvBufSurfaceFromFd(fd, (void**) &nvbuf_surf);
	if (!nvbuf_surf)
	{
		LOG_E("Failed to get NvBufSurface from Fd");
		return false;
	}

	VkImportMemoryFdInfoKHR import_fd_info = {0};
	import_fd_info.sType = VK_STRUCTURE_TYPE_IMPORT_MEMORY_FD_INFO_KHR;
	import_fd_info.fd = fd;
	import_fd_info.handleType = VK_EXTERNAL_MEMORY_HANDLE_TYPE_OPAQUE_FD_BIT ;
	import_fd_info.pNext = NULL;

	VkMemoryAllocateInfo allocate_info = {0};
	allocate_info.sType = VK_STRUCTURE_TYPE_MEMORY_ALLOCATE_INFO;
	// allocate_info.allocationSize = nvbuf_surf->surfaceList[0].planeParams.psize[0] + nvbuf_surf->surfaceList[0].planeParams.psize[1];
	allocate_info.allocationSize = 3840 * 2160 * 3;
	allocate_info.memoryTypeIndex = 0;
	allocate_info.pNext = &import_fd_info;
	// allocate_info.pNext = NULL;

	if (VK_SUCCESS != vkAllocateMemory(ctx->device, &allocate_info, NULL, vkmem))
	{
		LOG_E("Failed to allocate memory");
		return false;
	}

	LOG_I("%d | Imported buffer with fd: %u", index, fd);

	return true;
}

void render_fini_device_memory(RenderCtx* ctx, VkDeviceMemory vkmem)
{
	vkFreeMemory(ctx->device, vkmem, NULL);
}
