#include "render.ph"

void render_log_vk_result(VkResult result)
{
	char* vk_result_name = NULL;
	switch (result)
	{
		case VK_SUCCESS:
			return;
			break;
	case VK_NOT_READY:
		vk_result_name = "VK_NOT_READY";
		break;
	case VK_TIMEOUT:
		vk_result_name = "VK_TIMEOUT";
		break;
	case VK_EVENT_SET:
		vk_result_name = "VK_EVENT_SET";
		break;
	case VK_EVENT_RESET:
		vk_result_name = "VK_EVENT_RESET";
		break;
	case VK_INCOMPLETE:
		vk_result_name = "VK_INCOMPLETE";
		break;
	case VK_ERROR_OUT_OF_HOST_MEMORY:
		vk_result_name = "VK_ERROR_OUT_OF_HOST_MEMORY";
		break;
	case VK_ERROR_OUT_OF_DEVICE_MEMORY:
		vk_result_name = "VK_ERROR_OUT_OF_DEVICE_MEMORY";
		break;
	case VK_ERROR_INITIALIZATION_FAILED:
		vk_result_name = "VK_ERROR_INITIALIZATION_FAILED";
		break;
	case VK_ERROR_DEVICE_LOST:
		vk_result_name = "VK_ERROR_DEVICE_LOST";
		break;
	case VK_ERROR_MEMORY_MAP_FAILED:
		vk_result_name = "VK_ERROR_MEMORY_MAP_FAILED";
		break;
	case VK_ERROR_LAYER_NOT_PRESENT:
		vk_result_name = "VK_ERROR_LAYER_NOT_PRESENT";
		break;
	case VK_ERROR_EXTENSION_NOT_PRESENT:
		vk_result_name = "VK_ERROR_EXTENSION_NOT_PRESENT";
		break;
	case VK_ERROR_FEATURE_NOT_PRESENT:
		vk_result_name = "VK_ERROR_FEATURE_NOT_PRESENT";
		break;
	case VK_ERROR_INCOMPATIBLE_DRIVER:
		vk_result_name = "VK_ERROR_INCOMPATIBLE_DRIVER";
		break;
	case VK_ERROR_TOO_MANY_OBJECTS:
		vk_result_name = "VK_ERROR_TOO_MANY_OBJECTS";
		break;
	case VK_ERROR_FORMAT_NOT_SUPPORTED:
		vk_result_name = "VK_ERROR_FORMAT_NOT_SUPPORTED";
		break;
	case VK_ERROR_FRAGMENTED_POOL:
		vk_result_name = "VK_ERROR_FRAGMENTED_POOL";
		break;
	case VK_ERROR_UNKNOWN:
		vk_result_name = "VK_ERROR_UNKNOWN";
		break;
	case VK_ERROR_OUT_OF_POOL_MEMORY:
		vk_result_name = "VK_ERROR_OUT_OF_POOL_MEMORY";
		break;
	case VK_ERROR_INVALID_EXTERNAL_HANDLE:
		vk_result_name = "VK_ERROR_INVALID_EXTERNAL_HANDLE";
		break;
	case VK_ERROR_FRAGMENTATION:
		vk_result_name = "VK_ERROR_FRAGMENTATION";
		break;
	case VK_ERROR_INVALID_OPAQUE_CAPTURE_ADDRESS:
		vk_result_name = "VK_ERROR_INVALID_OPAQUE_CAPTURE_ADDRESS";
		break;
	case VK_ERROR_SURFACE_LOST_KHR:
		vk_result_name = "VK_ERROR_SURFACE_LOST_KHR";
		break;
	case VK_ERROR_NATIVE_WINDOW_IN_USE_KHR:
		vk_result_name = "VK_ERROR_NATIVE_WINDOW_IN_USE_KHR";
		break;
	case VK_SUBOPTIMAL_KHR:
		vk_result_name = "VK_SUBOPTIMAL_KHR";
		break;
	case VK_ERROR_OUT_OF_DATE_KHR:
		vk_result_name = "VK_ERROR_OUT_OF_DATE_KHR";
		break;
	case VK_ERROR_INCOMPATIBLE_DISPLAY_KHR:
		vk_result_name = "VK_ERROR_INCOMPATIBLE_DISPLAY_KHR";
		break;
	case VK_ERROR_VALIDATION_FAILED_EXT:
		vk_result_name = "VK_ERROR_VALIDATION_FAILED_EXT";
		break;
	case VK_ERROR_INVALID_SHADER_NV:
		vk_result_name = "VK_ERROR_INVALID_SHADER_NV";
		break;
#ifdef VK_ENABLE_BETA_EXTENSIONS
	case VK_ERROR_IMAGE_USAGE_NOT_SUPPORTED_KHR:
		vk_result_name = "VK_ERROR_IMAGE_USAGE_NOT_SUPPORTED_KHR";
		break;
#endif
#ifdef VK_ENABLE_BETA_EXTENSIONS
	case VK_ERROR_VIDEO_PICTURE_LAYOUT_NOT_SUPPORTED_KHR:
		vk_result_name = "VK_ERROR_VIDEO_PICTURE_LAYOUT_NOT_SUPPORTED_KHR";
		break;
#endif
#ifdef VK_ENABLE_BETA_EXTENSIONS
	case VK_ERROR_VIDEO_PROFILE_OPERATION_NOT_SUPPORTED_KHR:
		vk_result_name = "VK_ERROR_VIDEO_PROFILE_OPERATION_NOT_SUPPORTED_KHR";
		break;
#endif
#ifdef VK_ENABLE_BETA_EXTENSIONS
	case VK_ERROR_VIDEO_PROFILE_FORMAT_NOT_SUPPORTED_KHR:
		vk_result_name = "VK_ERROR_VIDEO_PROFILE_FORMAT_NOT_SUPPORTED_KHR";
		break;
#endif
#ifdef VK_ENABLE_BETA_EXTENSIONS
	case VK_ERROR_VIDEO_PROFILE_CODEC_NOT_SUPPORTED_KHR:
		vk_result_name = "VK_ERROR_VIDEO_PROFILE_CODEC_NOT_SUPPORTED_KHR";
		break;
#endif
#ifdef VK_ENABLE_BETA_EXTENSIONS
	case VK_ERROR_VIDEO_STD_VERSION_NOT_SUPPORTED_KHR:
		vk_result_name = "VK_ERROR_VIDEO_STD_VERSION_NOT_SUPPORTED_KHR";
		break;
#endif
	case VK_ERROR_INVALID_DRM_FORMAT_MODIFIER_PLANE_LAYOUT_EXT:
		vk_result_name = "VK_ERROR_INVALID_DRM_FORMAT_MODIFIER_PLANE_LAYOUT_EXT";
		break;
	case VK_ERROR_FULL_SCREEN_EXCLUSIVE_MODE_LOST_EXT:
		vk_result_name = "VK_ERROR_FULL_SCREEN_EXCLUSIVE_MODE_LOST_EXT";
		break;
		default:
			vk_result_name = "Unknown";
			break;
	}

	LOG_E("VkResult: %s", vk_result_name);
	return;
}
