#include "render.ph"

void render_fini(RenderCtx* ctx)
{
	CK_PTR(ctx);

	vkDestroySurfaceKHR(ctx->instance, ctx->surface, NULL);

	// Device Extensions
	if (ctx->device_extensions)
	{
		free(ctx->device_extensions);
	}
	free(ctx->device_extension_properties);

	vkDestroyDevice(ctx->device, NULL);

	// Queue Families
	if (ctx->queue_families)
	{
		free(ctx->queue_families);
	}
	free(ctx->queue_family_properties);

	// Devices
	free(ctx->physical_devices);

	// Extensions
	if (ctx->extensions)
	{
		free(ctx->extensions);
	}
	free(ctx->extension_properties);

	// Layers
	if (ctx->layers)
	{
		free(ctx->layers);
	}
	free(ctx->layer_properties);

	if (ctx->enable_validation_layers)
	{
		render_fini_debug_messenger(ctx);
	}

	vkDestroyInstance(ctx->instance, NULL);

	free(ctx);

	return;
error:
	return;
}
