#include <stdio.h>

#define LOG_D(fmt, ...)\
	printf("DBG %s:%d; "fmt"\n", __FILE__, __LINE__, ##__VA_ARGS__)

#define LOG_I(fmt, ...)\
	printf("INF %s:%d; "fmt"\n", __FILE__, __LINE__, ##__VA_ARGS__)

#define LOG_W(fmt, ...)\
	printf("WRN %s:%d; "fmt"\n", __FILE__, __LINE__, ##__VA_ARGS__)

#define LOG_E(fmt, ...)\
	printf("ERR %s:%d; "fmt"\n", __FILE__, __LINE__, ##__VA_ARGS__)

#define CK_PTR(ptr)\
	if (!ptr)\
	{\
		LOG_E("%s was NULL", #ptr);\
		goto error;\
	}

#define CK_BOOL(val)\
	if (!val)\
	{\
		LOG_E("%s was false", #val);\
		goto error;\
	}

#define CK_NONZERO(val)\
	if (val == 0)\
		{\
		LOG_E("%s was 0", #val);\
		goto error;\
	}
